#ifndef CONFIG_H
#define CONFIG_H

#define MOD Mod4Mask
#define SFT ShiftMask
#define ALT Mod1Mask

#define BORDER_COLOR "#727a18"
#define BORDER_WIDTH 3

const char* menu[]    = {"dmenu_run",      0};
const char* term[]    = {"st",             0};

static struct key keys[] = {
    {MOD,      XK_q,   win_kill,   {0}},
    {MOD,      XK_c,   win_center, {0}},
    {MOD,      XK_f,   win_fs,     {0}},
    {MOD,      XK_e,   wm_exit,    {0}},

    {MOD,           XK_k,  win_move,  {.com = (const char*[]){"move",   "n"}, .i = 10}},
    {MOD,           XK_j,  win_move,  {.com = (const char*[]){"move",   "s"}, .i = 10}},
    {MOD,           XK_l,  win_move,  {.com = (const char*[]){"move",   "e"}, .i = 10}},
    {MOD,           XK_h,  win_move,  {.com = (const char*[]){"move",   "w"}, .i = 10}},
 
    {MOD|SFT,       XK_k,  win_move,  {.com = (const char*[]){"resize", "n"}, .i = 10}},
    {MOD|SFT,       XK_j,  win_move,  {.com = (const char*[]){"resize", "s"}, .i = 10}},
    {MOD|SFT,       XK_l,  win_move,  {.com = (const char*[]){"resize", "e"}, .i = 10}},
    {MOD|SFT,       XK_h,  win_move,  {.com = (const char*[]){"resize", "w"}, .i = 10}},

    {MOD|ALT,       XK_k,  win_half,  {.com = (const char*[]){"n"}}},
    {MOD|ALT,       XK_j,  win_half,  {.com = (const char*[]){"s"}}},
    {MOD|ALT,       XK_l,  win_half,  {.com = (const char*[]){"e"}}},
    {MOD|ALT,       XK_h,  win_half,  {.com = (const char*[]){"w"}}},

    {ALT,           XK_Tab, win_next,   {0}},

    {MOD, XK_d,      run, {.com = menu}},
    {MOD, XK_Return, run, {.com = term}},

    {MOD,           XK_1, ws_go,     {.i = 1}},
    {MOD|SFT,       XK_1, win_to_ws, {.i = 1}},
    {MOD,           XK_2, ws_go,     {.i = 2}},
    {MOD|SFT,       XK_2, win_to_ws, {.i = 2}},
    {MOD,           XK_3, ws_go,     {.i = 3}},
    {MOD|SFT,       XK_3, win_to_ws, {.i = 3}},
    {MOD,           XK_4, ws_go,     {.i = 4}},
    {MOD|SFT,       XK_4, win_to_ws, {.i = 4}},
    {MOD,           XK_5, ws_go,     {.i = 5}},
    {MOD|SFT,       XK_5, win_to_ws, {.i = 5}},
    {MOD,           XK_6, ws_go,     {.i = 6}},
    {MOD|SFT,       XK_6, win_to_ws, {.i = 6}},
};

#endif
